#include <iostream>
#include <memory.h>
#include <stdio.h>
#include <string.h>
#include <atomic>


#include <memory>
#include <thread>
#include <chrono>
#include <mutex>
#include <functional>

//http://en.cppreference.com/w/cpp/memory/shared_ptr


using namespace std;


class StringContainer
{
public:
	StringContainer();
	virtual ~StringContainer()
	{
		printf("~StringContainer() Ҹ : %x : %s\n", this, m_myname.c_str());
	}

	string m_myname;
	char tmp_array[32];
};

StringContainer::StringContainer()
{
	printf("StringContainer()  : %x : %s\n", this, m_myname.c_str());
	printf("this         :  %x\n", this);
	printf("tmp_array    :  %x\n", tmp_array);

	memset(tmp_array, 0, sizeof(tmp_array));
	strcpy(tmp_array, "dream comes true!!!");
}


long long extern_raw_cstring_address;
std::shared_ptr<StringContainer> ext_cr;


//http://blog.naver.com/lobo_prix/220421546490

//function A()
void A()
{
	printf("---------------------------------------------------------A()\n");
	StringContainer * p = new StringContainer();
	p->m_myname = "A()";

#if 0
͸ ϴ ??
	std::shared_ptr<StringContainer>* p = (shared_ptr<StringContainer>*)new StringContainer();
    shared_ptr<StringContainer> sp2 = shared_ptr<StringContainer>(p);
    shared_ptr<StringContainer> sp1(p);
#endif

	//shared_ptr   ϸ. Լ return ɶ. Ҹڰ Բ ȣ˴ϴ. 
	//shared_ptr   ּҸ Բ ϸ  ߻մϴ.
    shared_ptr<StringContainer> sp1(p);

	extern_raw_cstring_address = (long long)p;
	
	printf("A() p                : %x\n", p           );
	printf("A() p->tmp_array     : %x\n", p->tmp_array);
	printf("A() p->tmp_array     : %s\n", p->tmp_array);
	printf("_msize               : %d\n", _msize(p)   );
}

//function B()
void B()
{
	printf("---------------------------------------------B()\n");

    std::shared_ptr<StringContainer> * test_cstring = reinterpret_cast<shared_ptr<StringContainer> * >(extern_raw_cstring_address); //ĳõ  ̻1

	StringContainer * p = (StringContainer*) test_cstring;

	printf("BB() p               : %x\n", p);
	printf("BB() p->tmp_array    : %s\n", p->tmp_array);
	printf("_msize               : %d\n", _msize(p));
}

void A2()
{
	printf("---------------------------------------------------------A2()\n");
	StringContainer * p = new StringContainer();
	p->m_myname = "A2()";
	ext_cr = shared_ptr<StringContainer>(p);
	printf("A2() p->tmp_array    : %x\n", p->tmp_array);
	printf("A2() p->tmp_array    : %s\n", p->tmp_array);
	printf("_msize               : %d\n", _msize(p));
} 

void B2()
{
	printf("---------------------------------------------B2()\n");
	StringContainer * p = ext_cr.get();

	printf("B2() p->tmp_array    : %x\n", p->tmp_array);
	printf("B2() p->tmp_array    : %s\n", p->tmp_array);
	printf("_msize               : %d\n", _msize(p));
//shared_ptr   ϴ. mainԼ return ɶ.
//Ҹڰ ڵ ȣ˴ϴ. delete p;   ʾƵ Ǵ 찡 ֽϴ.
}


int n;
void AA()
{
	printf("---------------------------------------------------------AA()\n");
	StringContainer * p = new StringContainer();
	p->m_myname = "AA()";

	n = (int)p;

	printf("AA() p    : %x\n", p);
	printf("AA() p    : %s\n", p->tmp_array);
	printf("_msize    :  %d\n", _msize(p));
}

void BB()
{
	printf("---------------------------------------------BB()\n");

	StringContainer * p = (StringContainer*)n;

	printf("BB() p    : %x\n", p);
	printf("BB() p    : %s\n", p->tmp_array);
	printf("_msize    :  %d\n", _msize(p));
	delete p;
}

void F1()
{
	printf("---------------------------------------------------------F1()\n");
	char * p = new char[100];
	strcpy(p, "test");
	n = (int)p;

	printf("F1() p    : %x\n", p);
	printf("F1() p    : %s\n", p);
	printf("_msize    :  %d\n", _msize(p));
}

void F2()
{
	printf("---------------------------------------------F2()\n");

	char * p = (char*)n;

	printf("F2() p    : %x\n", p);
	printf("F2() p    : %s\n", p);
	printf("_msize    :  %d\n", _msize(p));
	delete [] p;
}


int main(int argc, char** argv) 
{

	A();
	B();

	A2();
	B2();
	
	AA();
	BB();

	F1();
	F2();

	printf("main end\n");
	return 0;
}
